<ng-container *ngIf="jobRun$ | async as jobRun; else elseBlock">
  <div class="page-header">
    <div class="page-header__title">
      <gng-go-back *ngIf="!jobRun || !jobRun.id"></gng-go-back>
      {{ jobRun.name }}
    </div>
    <xrd-job-run-tools
      [viewAvailable]="false"
      [copyAvailable]="true"
      [deleteAvailable]="true"
      [compareAvailable]="false"
      [exportAvailable]="true"
      [run]="jobRun"
      (remove)="removeRun($event)"
    >
    </xrd-job-run-tools>
  </div>
  <div class="page-sub-header">
    <div class="minerals-wrapper">
      <div class="minerals-title">
        Minerals:
      </div>
      <xrd-minerals-panel [minerals]="minerals$ | async"></xrd-minerals-panel>
    </div>
    <div class="page-sub-header__tools">
      Raw Data:
      <div class="raw-data-btn" (click)="openRawData()">View Raw Data</div>
    </div>
  </div>
  <div class="content">
    <div class="controls" *ngIf="canSave(jobRun)">
      <button mat-raised-button type="button" color="accent" [disabled]="isOptimizing$ | async" (click)="optimizeRun()">
        Optimize
        <mat-icon *ngIf="isOptimizing$ | async">
          <mat-spinner diameter="20"> </mat-spinner>
        </mat-icon>
      </button>
      <button mat-raised-button type="button" color="primary" [disabled]="isSaving$ | async" (click)="saveRun()">
        Save<mat-icon *ngIf="isSaving$ | async">
          <mat-spinner diameter="20"> </mat-spinner>
        </mat-icon>
      </button>
    </div>
    <div class="charts-wrapper">
      <xrd-scatter-chart
        class="run-chart"
        [data]="scatterChartData$ | async"
        [title]="'Grain Density Comparison'"
      ></xrd-scatter-chart>
      <xrd-pie-chart
        class="run-chart"
        *ngIf="pieChartData$ | async as pieChartData"
        [data]="pieChartData.data"
        [title]="pieChartData.title"
      ></xrd-pie-chart>
    </div>
    <div class="charts-wrapper">
      <xrd-stacked-bar-chart
        class="run-chart stacked-bar-chart"
        *ngIf="stackedBarChartData$ | async as barChartData"
        [data]="barChartData"
        [title]="'Mineral Distribution'"
      ></xrd-stacked-bar-chart>
    </div>

    <xrd-densities-table class="densities-table" [data]="jobRun"></xrd-densities-table>

    <xrd-minerals-table class="run-table" [data]="jobRun.xrdAlgorithmResult" (selectRow)="onSelectRow($event)">
    </xrd-minerals-table>

    <div class="controls" *ngIf="canSave(jobRun)">
      <button mat-raised-button type="button" color="accent" [disabled]="isOptimizing$ | async" (click)="optimizeRun()">
        Optimize
        <mat-icon *ngIf="isOptimizing$ | async">
          <mat-spinner diameter="20"> </mat-spinner>
        </mat-icon>
      </button>
      <button mat-raised-button type="button" color="primary" [disabled]="isSaving$ | async" (click)="saveRun()">
        Save<mat-icon *ngIf="isSaving$ | async">
          <mat-spinner diameter="20"> </mat-spinner>
        </mat-icon>
      </button>
    </div>
  </div>
</ng-container>
<ng-template #elseBlock>
  <gng-spinner></gng-spinner>
</ng-template>
